| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
Gaudi::MetaDataSvc Class Reference

`#include <src/MetaDataSvc/MetaDataSvc.h>`

Inheritance diagram for Gaudi::MetaDataSvc:
[legend]
Collaboration diagram for Gaudi::MetaDataSvc:
[legend]

## Public Member Functions
| ~MetaDataSvc () override=default
StatusCode | start () override
bool | isEnabled () const
StatusCode | collectData ()
MetaData * | getMetaData () override
std::map< std::string, std::string > | getMetaDataMap () override
Public Member Functions inherited from extends< Service, IMetaDataSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Private Attributes
Gaudi::Property< bool > | m_isEnabled {this, "Enabled", true}
std::map< std::string, std::string > | m_metadata

## Additional Inherited Members
Public Types inherited from extends< Service, IMetaDataSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Definition at line 15 of file MetaDataSvc.h.

## Constructor & Destructor Documentation

Gaudi::MetaDataSvc::~MetaDataSvc | ( |  | ) |
| override default

## Member Function Documentation

StatusCode MetaDataSvc::collectData | ( |  | ) |

Definition at line 61 of file MetaDataSvc.cpp.

62 {
63 std::string temp;
64 bool first{false};
65
66 auto appMgr = service<IProperty>( "ApplicationMgr" );
67 if ( appMgr.isValid() ) {
68 const std::vector<Gaudi::Details::PropertyBase*> properties = appMgr->getProperties();
69 for ( int i = 0; i < (signed)properties.size(); i++ ) {
70 temp = "ApplicationMgr." + properties[i]->name();
71 m_metadata[temp] = properties[i]->toString();
72 }
73 }
74 auto mSvc = service<IProperty>( "MessageSvc" );
75 if ( mSvc.isValid() ) {
76 const std::vector<Gaudi::Details::PropertyBase*> properties2 = mSvc->getProperties();
77 for ( int i = 0; i < (signed)properties2.size(); i++ ) {
78 temp = "MessageSvc." + properties2[i]->name();
79 m_metadata[temp] = properties2[i]->toString();
80 }
81 }
82
83 auto nSvc = service<IProperty>( "NTupleSvc" );
84 if ( nSvc.isValid() ) {
85 const std::vector<Gaudi::Details::PropertyBase*> properties5 = nSvc->getProperties();
86 for ( int i = 0; i < (signed)properties5.size(); i++ ) {
87 temp = "NTupleSvc." + properties5[i]->name();
88 m_metadata[temp] = properties5[i]->toString();
89 }
90 }
91
92 /*
93 * TOOLS
94 * */
95 SmartIF<IToolSvc> tSvc( serviceLocator()->service( "ToolSvc" ) );
96 if ( tSvc.isValid() ) {
97 std::vector<std::string> TSvcs = tSvc->getInstances( "" );
98 temp = "";
99 for ( int i = 0; i < (signed)TSvcs.size(); i++ ) {
100 temp += TSvcs[i];
101 if ( i != (signed)TSvcs.size() - 1 ) temp += ", ";
102 }
103 m_metadata["ToolSvc"] = temp;
104 }
105
106 /*
107 * SERVICES
108 * */
109 auto Svcs = serviceLocator()->getServices();
110 temp = "";
111 first = true;
112 for ( auto svc : Svcs ) {
113 if ( !first )
114 temp += ", ";
115 else
116 first = false;
117 temp += svc->name();
118 }
119 m_metadata["ISvcLocator.Services"] = temp;
120
121 /*
122 * ALGORITHMS
123 * */
124 SmartIF<IAlgManager> algMan( serviceLocator() );
125 auto allAlgs = algMan->getAlgorithms();
126 temp = "";
127 first = true;
128 for ( auto alg : allAlgs ) {
129 if ( !first )
130 temp += ", ";
131 else
132 first = false;
133 temp += alg->name();
134 }
135 m_metadata["IAlgManager.Algorithms"] = temp;
136
137 /*
138 * JOB OPTIONS SERVICE
139 * */
140 auto joSvc = service<IProperty>( "JobOptionsSvc" );
141 if ( !joSvc.isValid() ) {
142 return StatusCode::FAILURE;
143 }
144 const std::vector<Gaudi::Details::PropertyBase*> properties7 = joSvc->getProperties();
145 for ( int i = 0; i < (signed)properties7.size(); i++ ) {
146 temp = "JobOptionsSvc." + properties7[i]->name();
147 m_metadata[temp] = properties7[i]->toString();
148 }
149
150 if ( msgLevel( MSG::DEBUG ) ) {
151 std::stringstream ss_metadata;
152 for ( auto item : m_metadata ) {
153 ss_metadata << item.first << ':' << item.second << '\n';
154 }
155 debug() << "Metadata collected:\n" << ss_metadata.str() << endmsg;
156 }
157
158 return StatusCode::SUCCESS;
159 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
SmartIF< IToolSvc >
StatusCode::FAILURE
Definition: StatusCode.h:29
MSG::DEBUG
Definition: IMessageSvc.h:18
std::stringstream
STL class.
std::string
STL class.
std::stringstream::str
T str(T...args)
std::vector::size
T size(T...args)
std::vector< Gaudi::Details::PropertyBase * >
gaudiComponentHelp.properties
properties
Definition: gaudiComponentHelp.py:37
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
IOTest.appMgr
appMgr
Definition: IOTest.py:83
ISvcLocator::getServices
virtual const std::list< IService * > & getServices() const =0
Get a reference to a service and create it if it does not exists.
Service::service
StatusCode service(const std::string &name, const T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Service.h:85
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:292
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
Gaudi::MetaDataSvc::m_metadata
std::map< std::string, std::string > m_metadata
Definition: MetaDataSvc.h:33

MetaData * MetaDataSvc::getMetaData | ( |  | ) |
| override

Definition at line 59 of file MetaDataSvc.cpp.

59 { return new MetaData( m_metadata ); }
MetaData
Definition: MetaData.h:21
Gaudi::MetaDataSvc::m_metadata
std::map< std::string, std::string > m_metadata
Definition: MetaDataSvc.h:33

std::map< std::string, std::string > MetaDataSvc::getMetaDataMap | ( |  | ) |
| override

Definition at line 60 of file MetaDataSvc.cpp.

60 { return m_metadata; }
Gaudi::MetaDataSvc::m_metadata
std::map< std::string, std::string > m_metadata
Definition: MetaDataSvc.h:33

bool Gaudi::MetaDataSvc::isEnabled | ( |  | ) | const
| inline

Definition at line 23 of file MetaDataSvc.h.

23 { return m_isEnabled; }
Gaudi::MetaDataSvc::m_isEnabled
Gaudi::Property< bool > m_isEnabled
Definition: MetaDataSvc.h:31

StatusCode MetaDataSvc::start | ( |  | ) |
| override

Definition at line 54 of file MetaDataSvc.cpp.

55 {
56 if ( msgLevel( MSG::DEBUG ) ) debug() << "started" << endmsg;
57 return collectData();
58 }
MSG::DEBUG
Definition: IMessageSvc.h:18
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:126
CommonMessagingBase::msgLevel
MSG::Level msgLevel() const
get the output level from the embedded MsgStream
Definition: CommonMessaging.h:135
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
Gaudi::MetaDataSvc::collectData
StatusCode collectData()
Definition: MetaDataSvc.cpp:61

## Member Data Documentation

Gaudi::Property<bool> Gaudi::MetaDataSvc::m_isEnabled {this, "Enabled", true}
| private

Definition at line 31 of file MetaDataSvc.h.

std::map<std::string, std::string> Gaudi::MetaDataSvc::m_metadata
| private

Definition at line 33 of file MetaDataSvc.h.

The documentation for this class was generated from the following files:

- GaudiSvc/src/MetaDataSvc/MetaDataSvc.h
- GaudiSvc/src/MetaDataSvc/MetaDataSvc.cpp